<div id="app" v-cloak>
    <el-card class="box-card">
        <el-form :inline="true" :model="vm" ref="vm" label-width="90px">
            <el-form-item label="角色名称" prop="roleName">
                <el-input v-model="vm.roleName" clearable size="small" placeholder=""></el-input>
            </el-form-item>
            <el-form-item label="角色代码" prop="roleCode">
                <el-input v-model="vm.roleCode" clearable size="small" placeholder=""></el-input>
            </el-form-item>
            <el-form-item>
                <el-button type="primary" size="small" icon="el-icon-search" @click="onSearch">搜索</el-button>
                <el-button type="warning" size="small" icon="el-icon-refresh-left" @click="onReset('vm')">重置</el-button>
            </el-form-item>
        </el-form>
    </el-card>

    <el-card class="box-card control">
        <a> Nginx 控制中心</a>
        <a @click="nginxStart">
            <el-image v-if="run" :src="'${Uri.getUrl('/static/img/start_.png')}'" style="width: 50px; height: 50px"
                      fit="fill"></el-image>
            <el-image v-if="!run" :src="'${Uri.getUrl('/static/img/start.png')}'" style="width: 50px; height: 50px"
                      fit="fill"></el-image>
        </a>

        <a @click="nginxStop">
            <el-image v-if="run" :src="'${Uri.getUrl('/static/img/stop.png')}'" style="width: 50px; height: 50px"
                      fit="fill"></el-image>
            <el-image v-if="!run" :src="'${Uri.getUrl('/static/img/stop_.png')}'" style="width: 50px; height: 50px"
                      fit="fill"></el-image>
        </a>
        <a @click="nginxReload">
            <el-image v-if="run" :src="'${Uri.getUrl('/static/img/reload.png')}'" style="width: 50px; height: 50px"
                      fit="fill"></el-image>
            <el-image v-if="!run" :src="'${Uri.getUrl('/static/img/reload_.png')}'" style="width: 50px; height: 50px"
                      fit="fill"></el-image>
        </a>
    </el-card>

    <el-card class="box-card">
        <el-row>
            <el-col :span="12">
                <el-button type="success" size="small" icon="el-icon-plus" @click="onAction(['create',''])">新增
                </el-button>
                <el-button type="warning" size="small" icon="el-icon-download">导出</el-button>

                <el-dialog :title="form.title" :visible.sync="form.dialog">
                    <el-form :model="form" :rules="formRules" ref="form" label-width="90px"
                             style="width: 290px;">
                        <el-form-item label="角色名称" prop="roleName">
                            <el-input v-model="form.roleName" clearable size="small" placeholder=""></el-input>
                        </el-form-item>
                        <el-form-item label="角色代码" prop="roleCode">
                            <el-input v-model="form.roleCode" clearable size="small" placeholder=""></el-input>
                        </el-form-item>
                    </el-form>
                    <span slot="footer" class="dialog-footer">
                        <el-button size="small" @click="form.dialog = false">取 消</el-button>
                        <el-button size="small" type="primary" @click="onAction(['save',''])">保存</el-button>
                    </span>
                </el-dialog>
            </el-col>

            <el-col :span="12">
                <el-button-group style="float: right;">
                    <el-button size="small" icon="el-icon-refresh" @click="onFind"></el-button>
                </el-button-group>
            </el-col>
        </el-row>

        <el-table
                @selection-change="onSelectionChange"
                empty-text="无数据"
                :data="result"
                size="small"
                style="width: 100%">
            <el-table-column
                    align="center"
                    type="selection"
                    width="50">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="id"
                    label="主键"
                    width="140">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="roleName"
                    label="角色名称">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="roleCode"
                    label="角色代码">
            </el-table-column>
            <el-table-column
                    align="center"
                    prop="createTime"
                    label="创建时间">
            </el-table-column>
            <el-table-column
                    align="center"
                    label="操作">
                <template slot-scope="scope">
                    <el-dropdown size="mini" split-button type="primary" @click="onAction(['roleRes',scope.row])"
                                 @command="onAction">
                        <i class="el-icon-edit"></i>编辑资源
                        <el-dropdown-menu slot="dropdown">
                            <el-dropdown-item :command="['edit',scope.row]" icon="el-icon-edit">编辑</el-dropdown-item>
                            <el-dropdown-item :command="['delete',scope.row]" icon="el-icon-delete">删除
                            </el-dropdown-item>
                        </el-dropdown-menu>
                    </el-dropdown>
                </template>
            </el-table-column>
        </el-table>

        <el-pagination
                v-if="vm.totalCount > vm.pageSize"
                @current-change="onPage"
                :current-page="vm.pageNumber"
                :page-size="vm.pageSize"
                layout="total, prev, pager, next, jumper"
                :total="vm.totalCount">
        </el-pagination>
    </el-card>
</div>
<style>
    #app {
        padding: 10px;
    }

    .box-card {
        margin: 10px;
    }

    .control a {
        display: inline-block;
        line-height: 50px;
        height: 50px;
        vertical-align: top;
    }

    .control a:hover {
        background: #e7e7e7;
    }

    .control a:first-child:hover {
        background: #ffffff;
    }
</style>
<script>
    var app = new Vue({
        el: "#app",
        data: {
            vm: {
                roleName: '',
                roleCode: '',
                pageNumber: 1,
                pageSize: 10,
                totalCount: 0
            },
            form: {
                title: "",
                dialog: false,
                id: '',
                roleName: '',
                roleCode: '',
                rowVersion: ''
            },
            formRules: {
                roleName: [
                    {required: true, message: '不能为空', trigger: 'blur'},
                    {min: 1, max: 50, message: '长度在 1 到 50 字符', trigger: 'blur'}
                ],
                roleCode: [
                    {required: true, message: '不能为空', trigger: 'blur'},
                    {min: 1, max: 50, message: '长度在 1 到 50 个字符', trigger: 'blur'}
                ],
            },
            select: [],
            result: [],
            run: ${run?default('false')}
        },
        methods: {
            onSearch: function () {
                this.vm.pageNumber = 1;
                this.onFind();
            },
            onReset: function (form) {
                this.$refs[form].resetFields();
                nav.w('重置成功');
            },
            onFind: function () {
                ajax.mappingFind(this.vm).then(function (response) {
                    if (response.errors.length > 0) {
                        nav.e(response.errors[0].message);
                    } else {
                        this.result = response.result;
                        this.totalCount = Number(response.totalCount);
                    }
                }.bind(this))
            },
            onPage: function (pageNumber) {
                this.vm.pageNumber = pageNumber;
                this.onFind();
            },
            onSelectionChange: function (select) {
                this.select = select;
            },
            onAction: function (arg) {
                const action = arg[0];
                const item = arg[1];
                switch (action) {
                    case "create":
                        this.form.title = '新增';
                        this.form.id = '';
                        this.form.roleName = '';
                        this.form.roleCode = '';
                        this.form.dialog = true;
                        break;
                    case "save":
                        if (this.form.id) {
                            ajax.roleUpdate(this.form).then(function (response) {
                                if (response.errors.length > 0) {
                                    nav.e(response.errors[0].message);
                                } else {
                                    this.onFind();
                                    this.form.dialog = false;
                                }
                            }.bind(this))
                        } else {
                            ajax.roleCreate(this.form).then(function (response) {
                                if (response.errors.length > 0) {
                                    nav.e(response.errors[0].message);
                                } else {
                                    this.onFind();
                                    this.form.dialog = false;
                                }
                            }.bind(this))
                        }
                        break;
                    case "edit":
                        this.form.title = '编辑';
                        this.form.id = item.id;
                        this.form.roleName = item.roleName;
                        this.form.roleCode = item.roleCode;
                        this.form.rowVersion = item.rowVersion;
                        this.form.dialog = true;
                        break;
                    case "delete":
                        this.$confirm('将删除该项, 是否继续?', '提示', {
                            confirmButtonText: '确定',
                            cancelButtonText: '取消',
                            type: 'warning'
                        }).then(function () {
                            ajax.roleDelete({id: item.id}).then(function (response) {
                                if (response.errors.length > 0) {
                                    nav.e(response.errors[0].message);
                                } else {
                                    nav.s("删除成功")
                                    this.onFind();
                                }
                            }.bind(this))
                        }.bind(this)).catch(function (action) {

                        });
                        break;
                }
            },
            startMonitor: function () {
                if (window.EventSource) {
                    window.evtSource = new EventSource('${Uri.getUrl("/sse/1")}');
                    window.evtSource.addEventListener('message', function (e) {

                        var msg = JSON.parse(e.data);
                        if (msg.type == 'NGINX_STATE') {//状态推送
                            if (this.run != msg.object.run) {

                                this.$notify.info({
                                    title: '提示',
                                    message: "Nginx 运行状态发生变化:"
                                });
                                this.run = msg.object.run;
                            }
                        }
                    }.bind(this))
                }
            },
            nginxStart: function () {
                ajax.nginxStart().then(function (response) {
                    if (response.errors.length > 0) {
                        nav.e(response.errors[0].message);
                    } else {
                        this.onFind();
                        this.form.dialog = false;
                    }
                }.bind(this))
            },
            nginxStop: function () {
                ajax.nginxStop().then(function (response) {
                    if (response.errors.length > 0) {
                        nav.e(response.errors[0].message);
                    } else {
                        this.onFind();
                        this.form.dialog = false;
                    }
                }.bind(this))
            },
            nginxReload: function () {
                ajax.nginxReload().then(function (response) {
                    if (response.errors.length > 0) {
                        nav.e(response.errors[0].message);
                    } else {
                        this.onFind();
                        this.form.dialog = false;
                    }
                }.bind(this))
            }
        },
        created: function () {
        },
        mounted: function () {
            this.onFind();
            this.startMonitor();
        },
        watch: {}
    })
</script>
